org.springframework.orm.hibernate4.support

## Class OpenSessionInViewInterceptor

- java.lang.Object
- - org.springframework.orm.hibernate4.support.OpenSessionInViewInterceptor

All Implemented Interfaces:
  AsyncWebRequestInterceptor, WebRequestInterceptor

    public class OpenSessionInViewInterceptor
    extends Object
    implements AsyncWebRequestInterceptor

Spring web request interceptor that binds a Hibernate `Session` to the thread for the entire processing of the request.

This class is a concrete expression of the "Open Session in View" pattern, which is a pattern that allows for the lazy loading of associations in web views despite the original transactions already being completed.

This interceptor makes Hibernate Sessions available via the current thread, which will be autodetected by transaction managers. It is suitable for service layer transactions via `HibernateTransactionManager` as well as for non-transactional execution (if configured appropriately).

In contrast to `OpenSessionInViewFilter`, this interceptor is configured in a Spring application context and can thus take advantage of bean wiring.

WARNING: Applying this interceptor to existing logic can cause issues that have not appeared before, through the use of a single Hibernate `Session` for the processing of an entire request. In particular, the reassociation of persistent objects with a Hibernate `Session` has to occur at the very beginning of request processing, to avoid clashes with already loaded instances of the same objects.

Since:
  3.1
Author:
  Juergen Hoeller
See Also:
  `OpenSessionInViewFilter`, `HibernateTransactionManager`, `TransactionSynchronizationManager`

### Field Summary

Fields
`protected Log` `logger`
`static String` `PARTICIPATE_SUFFIX` Suffix that gets appended to the `SessionFactory` `toString()` representation for the "participate in existing session handling" request attribute.

### Constructor Summary

Constructors
Constructor and Description
`OpenSessionInViewInterceptor()`

### Method Summary

Methods
`void` `afterCompletion(WebRequest request, Exception ex)` Unbind the Hibernate `Session` from the thread and close it).
`void` `afterConcurrentHandlingStarted(WebRequest request)` Called instead of `postHandle` and `afterCompletion`, when the the handler started handling the request concurrently.
`protected String` `getParticipateAttributeName()` Return the name of the request attribute that identifies that a request is already intercepted.
`SessionFactory` `getSessionFactory()`
`protected Session` `openSession()` Open a Session for the SessionFactory that this interceptor uses.
`void` `postHandle(WebRequest request, ModelMap model)` Intercept the execution of a request handler after its successful invocation, right before view rendering (if any).
`void` `preHandle(WebRequest request)` Open a new Hibernate `Session` according to the settings of this `HibernateAccessor` and bind it to the thread via the `TransactionSynchronizationManager`.
`void` `setSessionFactory(SessionFactory sessionFactory)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### PARTICIPATE_SUFFIX

    public static final String PARTICIPATE_SUFFIX

Suffix that gets appended to the `SessionFactory` `toString()` representation for the "participate in existing session handling" request attribute.

See Also:
  `getParticipateAttributeName()`, Constant Field Values

#### logger

    protected final Log logger

### Constructor Detail

#### OpenSessionInViewInterceptor

    public OpenSessionInViewInterceptor()

### Method Detail

#### setSessionFactory

    public void setSessionFactory(SessionFactory sessionFactory)

#### getSessionFactory

    public SessionFactory getSessionFactory()

#### preHandle

    public void preHandle(WebRequest request)
                   throws DataAccessException

Open a new Hibernate `Session` according to the settings of this `HibernateAccessor` and bind it to the thread via the `TransactionSynchronizationManager`.

Specified by:
  `preHandle` in interface `WebRequestInterceptor`
Parameters:
  `request` - the current web request
Throws:
  `DataAccessException`

#### postHandle

    public void postHandle(WebRequest request,
                  ModelMap model)

Description copied from interface: `WebRequestInterceptor`
Intercept the execution of a request handler after its successful invocation, right before view rendering (if any).

Allows for modifying context resources after successful handler execution (for example, flushing a Hibernate Session).

Specified by:
  `postHandle` in interface `WebRequestInterceptor`
Parameters:
  `request` - the current web request
  `model` - the map of model objects that will be exposed to the view (may be `null`). Can be used to analyze the exposed model and/or to add further model attributes, if desired.

#### afterCompletion

    public void afterCompletion(WebRequest request,
                       Exception ex)
                         throws DataAccessException

Unbind the Hibernate `Session` from the thread and close it).

Specified by:
  `afterCompletion` in interface `WebRequestInterceptor`
Parameters:
  `request` - the current web request
  `ex` - exception thrown on handler execution, if any
Throws:
  `DataAccessException`
See Also:
  `TransactionSynchronizationManager`

#### afterConcurrentHandlingStarted

    public void afterConcurrentHandlingStarted(WebRequest request)

Description copied from interface: `AsyncWebRequestInterceptor`
Called instead of `postHandle` and `afterCompletion`, when the the handler started handling the request concurrently.

Specified by:
  `afterConcurrentHandlingStarted` in interface `AsyncWebRequestInterceptor`
Parameters:
  `request` - the current request

#### openSession

    protected Session openSession()
                           throws DataAccessResourceFailureException

Open a Session for the SessionFactory that this interceptor uses.

The default implementation delegates to the `SessionFactory.openSession` method and sets the `Session`'s flush mode to "MANUAL".

Returns:
  the Session to use
Throws:
  `DataAccessResourceFailureException` - if the Session could not be created
See Also:
  `FlushMode.MANUAL`

#### getParticipateAttributeName

    protected String getParticipateAttributeName()

Return the name of the request attribute that identifies that a request is already intercepted.

The default implementation takes the `toString()` representation of the `SessionFactory` instance and appends `PARTICIPATE_SUFFIX`.